/*
 * $Id$
 */

package npanday.model.compiler.plugins;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * null
 * 
 * @version $Revision$ $Date$
 */
public class ExecutablePlugin implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field identifier
     */
    private String identifier;

    /**
     * Field pluginClass
     */
    private String pluginClass;

    /**
     * Field vendor
     */
    private String vendor;

    /**
     * Field profile
     */
    private String profile;

    /**
     * Field executable
     */
    private String executable;

    /**
     * Field frameworkVersions
     */
    private java.util.List frameworkVersions;

    /**
     * Field platforms
     */
    private java.util.List platforms;

    /**
     * Field commandFilter
     */
    private CommandFilter commandFilter;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addFrameworkVersion
     * 
     * @param string
     */
    public void addFrameworkVersion(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "ExecutablePlugin.addFrameworkVersions(string) parameter must be instanceof " + String.class.getName() );
        }
        getFrameworkVersions().add( string );
    } //-- void addFrameworkVersion(String) 

    /**
     * Method addPlatform
     * 
     * @param platform
     */
    public void addPlatform(Platform platform)
    {
        if ( !(platform instanceof Platform) )
        {
            throw new ClassCastException( "ExecutablePlugin.addPlatforms(platform) parameter must be instanceof " + Platform.class.getName() );
        }
        getPlatforms().add( platform );
    } //-- void addPlatform(Platform) 

    /**
     * Get A filter for including/excluding user-passed commands
     * options.
     */
    public CommandFilter getCommandFilter()
    {
        return this.commandFilter;
    } //-- CommandFilter getCommandFilter() 

    /**
     * Get Executable, as run from the command line.
     */
    public String getExecutable()
    {
        return this.executable;
    } //-- String getExecutable() 

    /**
     * Method getFrameworkVersions
     */
    public java.util.List getFrameworkVersions()
    {
        if ( this.frameworkVersions == null )
        {
            this.frameworkVersions = new java.util.ArrayList();
        }
        
        return this.frameworkVersions;
    } //-- java.util.List getFrameworkVersions() 

    /**
     * Get An id for the compiler. It should be (but is not
     * required to be) unique.
     */
    public String getIdentifier()
    {
        return this.identifier;
    } //-- String getIdentifier() 

    /**
     * Method getPlatforms
     */
    public java.util.List getPlatforms()
    {
        if ( this.platforms == null )
        {
            this.platforms = new java.util.ArrayList();
        }
        
        return this.platforms;
    } //-- java.util.List getPlatforms() 

    /**
     * Get 
     *             Class name of the compiler. NPanday will pass an
     * instance of this class to the
     *             requesting plugin.
     *           
     */
    public String getPluginClass()
    {
        return this.pluginClass;
    } //-- String getPluginClass() 

    /**
     * Get Profile for the plugin.
     */
    public String getProfile()
    {
        return this.profile;
    } //-- String getProfile() 

    /**
     * Get Vendor of the compiler: MICROSOFT, MONO, DotGNU
     */
    public String getVendor()
    {
        return this.vendor;
    } //-- String getVendor() 

    /**
     * Method removeFrameworkVersion
     * 
     * @param string
     */
    public void removeFrameworkVersion(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "ExecutablePlugin.removeFrameworkVersions(string) parameter must be instanceof " + String.class.getName() );
        }
        getFrameworkVersions().remove( string );
    } //-- void removeFrameworkVersion(String) 

    /**
     * Method removePlatform
     * 
     * @param platform
     */
    public void removePlatform(Platform platform)
    {
        if ( !(platform instanceof Platform) )
        {
            throw new ClassCastException( "ExecutablePlugin.removePlatforms(platform) parameter must be instanceof " + Platform.class.getName() );
        }
        getPlatforms().remove( platform );
    } //-- void removePlatform(Platform) 

    /**
     * Set A filter for including/excluding user-passed commands
     * options.
     * 
     * @param commandFilter
     */
    public void setCommandFilter(CommandFilter commandFilter)
    {
        this.commandFilter = commandFilter;
    } //-- void setCommandFilter(CommandFilter) 

    /**
     * Set Executable, as run from the command line.
     * 
     * @param executable
     */
    public void setExecutable(String executable)
    {
        this.executable = executable;
    } //-- void setExecutable(String) 

    /**
     * Set Supported framework version(s) of the compiler:
     * 1.1.4322, 2.0.50727, 3.0
     * 
     * @param frameworkVersions
     */
    public void setFrameworkVersions(java.util.List frameworkVersions)
    {
        this.frameworkVersions = frameworkVersions;
    } //-- void setFrameworkVersions(java.util.List) 

    /**
     * Set An id for the compiler. It should be (but is not
     * required to be) unique.
     * 
     * @param identifier
     */
    public void setIdentifier(String identifier)
    {
        this.identifier = identifier;
    } //-- void setIdentifier(String) 

    /**
     * Set Platform configuration capabilities.
     * 
     * @param platforms
     */
    public void setPlatforms(java.util.List platforms)
    {
        this.platforms = platforms;
    } //-- void setPlatforms(java.util.List) 

    /**
     * Set 
     *             Class name of the compiler. NPanday will pass an
     * instance of this class to the
     *             requesting plugin.
     *           
     * 
     * @param pluginClass
     */
    public void setPluginClass(String pluginClass)
    {
        this.pluginClass = pluginClass;
    } //-- void setPluginClass(String) 

    /**
     * Set Profile for the plugin.
     * 
     * @param profile
     */
    public void setProfile(String profile)
    {
        this.profile = profile;
    } //-- void setProfile(String) 

    /**
     * Set Vendor of the compiler: MICROSOFT, MONO, DotGNU
     * 
     * @param vendor
     */
    public void setVendor(String vendor)
    {
        this.vendor = vendor;
    } //-- void setVendor(String) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }}
